<template>
  <div class="w-[80%] relative left-[10%] top-[15%] mt-12 overflow-x-hidden">
    <div>
      <vueper-slides v-if="slides.length" arrowsOutside bullets-outside :dragging-distance="50">
        <vueper-slide
            v-for="(slide, i) in slides"
            :key="i"
            :image="slide.image"
            :title="slide.title"
            :content="slide.content"
            @click="goToDetail(slide.id)"
            style="color:white; border-radius: 10px; overflow: hidden;"
            class="bg-opacity-70"
        >
          <template #content>
            <div class="flex flex-col justify-center items-center w-full h-full relative">
              <h2 class="font-extrabold text-6xl px-24">{{ slide.title }}</h2>
              <h3 class="font-extrabold text-3xl">{{ slide.content }}</h3>
              <h5 class="absolute top-2 left-2 jp-text text-2xl">{{ slide.content }}</h5>
              <h5 class="absolute right-2 bottom-2 jp-text text-2xl">{{ slide.content }}</h5>
            </div>
          </template>
        </vueper-slide>
      </vueper-slides>
    </div>
    <div v-for="(mangas,genre) in feedMangas" class="w-full my-12">
      <h3 class="text-2xl font-bold underline underline-offset-2 mb-2">{{ genre }}</h3>
      <div class="w-full grid grid-cols-5 gap-y-4 gap-x-2">
        <div v-for="manga in mangas" class="col-span-1 text-white">
          <div class="w-48 h-80 relative flex w-full h-full items-center justify-center rounded-md bg-cover cursor-pointer" :style="`background-image:url(${manga.picture})`"  @click="goToDetail(manga.api_id)">
            <div
          class="overlay absolute top-0 right-0 w-full h-full bg-black bg-opacity-30 flex items-center justify-center text-white cursor-pointer"
      >
            <h4 class="text-xl text-center font-semibold">{{ manga.title }}</h4>
            <h5 class="jp-text absolute top-2 left-2 opacity-40 text-gray-100">{{ manga.jap_title }}</h5>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>

</template>


<script>
import {VueperSlide, VueperSlides} from 'vueperslides'
import 'vueperslides/dist/vueperslides.css'
import randomGradients from "../helpers/randomGradients.js";
import title from "../helpers/title.js";

export default {
  name: "Home.vue",
  components: {VueperSlides, VueperSlide},

  data() {
    return {
      connected: false,
      slides: [],
      feedMangas: {}
    }
  },

  methods: {
    randomGradients,
    async mangaSlides() {
      this.slides = (await this.$axios.get('/feed/top?count=5')).data.map(manga => ({
        id: manga.api_id,
        title: manga.title,
        content: manga.jap_title,
        image: manga.picture,
        gradient: randomGradients()
      }))
    },
    goToDetail(id) {
      this.$router.push({path: `/mangas/${id}`})
    }
  },

  async mounted() {
    title('Home')
    await this.mangaSlides()
    let genres = (await this.$axios.get('/genres')).data
    for (let i = 0; i < genres.length; i++) {
      let mangas = ((await this.$axios.get(`genres/${genres[i].id}/relations/mangas`)).data).slice(0, 10)
      mangas = mangas.map(manga => {
        if(!manga.jap_title){
          let hasColumn = manga.title.includes(':')
            manga.jap_title = hasColumn ? manga.title.split(':')[0] : manga.title.split(' ')[0]
        }
        return {...manga, gradient: randomGradients()}
      })
      this.feedMangas[genres[i].name] = mangas
    }
  }
}
</script>